/*******************************************************************************
 *  Copyright 2017-2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.templates.cid;


import cdac.medinfo.sdk.dcm30_04.templates.dicomsnomedmap.BreastGYNMammoSNOMEDMap;
import cdac.medinfo.sdk.dcm30_04.templates.enums.EnumCodingSchemeDesignator;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_MammoplastyProcedures;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cv.EnumCV_MammoplastyProcedures;


/**
 * This class represents MammoplastyProcedures - CID6084
 */
public class MammoplastyProcedures_CID6084
{
	
	/**
	 * The Code Value for template.
	 */
	private String strCodeValue = null;

	/**
	 * The Code Meaning for template.
	 */
	private String strCodeMeaning = null;

	/**
	 * The Coding Scheme Designator for template.
	 */
	private String strCodingSchemeDesignator;
	/**
	 * The SNOMED CT ID for template.
	 */
	private String strSNOMEDCTID = null;
	/**
	 * Instantiates a new MammoplastyProcedures_CID6084 Template 
	 */
	public MammoplastyProcedures_CID6084()
	{

	}

	/**
	 * Retrieves the value for Code Meaning.
	 * @return String value for Code Meaning.
	 */
	public String getCodeMeaning()
	{
		return strCodeMeaning;
	}

	/**
	 * Retrieves the value for Code Value.
	 * @return String value for Code Value.
	 */
	public String getCodeValue() 
	{
		return strCodeValue;
	}

	/**
	 * Retrieves the value for Coding Scheme Designator.
	 * @return String value for Coding Scheme Designator.
	 */
	public String getCodingSchemeDesignator() 
	{
		return strCodingSchemeDesignator;
	}
	/**
	 * Retrieves the value for SNOMED-CT ID.
	 * @return String value for SNOMED-CT ID.
	 */
	public String getSNOMEDCTID() 
	{
		return strSNOMEDCTID;
	}
	/**
	 * Sets the Code Value according to Code Meaning.
	 * @param enumMammoplastyProcedures Object of EnumCM_MammoplastyProcedures represents Code Meaning.
	 */
	private void setCodeValue(EnumCM_MammoplastyProcedures enumMammoplastyProcedures)
	{
		switch(enumMammoplastyProcedures)
		{
		case BREAST_IMPLANTATION: this.strCodeValue = EnumCV_MammoplastyProcedures.BREAST_IMPLANTATION_P1_48501.getValue();break;
		case REDUCTION_MAMMOPLASTY: this.strCodeValue = EnumCV_MammoplastyProcedures.REDUCTION_MAMMOPLASTY_P1_48830.getValue();break;
		case BREAST_RECONSTRUCTION: this.strCodeValue = EnumCV_MammoplastyProcedures.BREAST_RECONSTRUCTION_P1_48820.getValue();break;
		case REMOVAL_OF_BREAST_IMPLANT: this.strCodeValue = EnumCV_MammoplastyProcedures.REMOVAL_OF_BREAST_IMPLANT_P1_48520.getValue();break;
		}
	}
	/**
	 * Sets the SNOMED-CT ID.
	 * @param enumMammoplastyProcedures Object of EnumCM_MammoplastyProcedures represents Code Meaning.
	 */
	private void setSNOMEDCTID(EnumCM_MammoplastyProcedures enumMammoplastyProcedures)
	{
		switch(enumMammoplastyProcedures)
		{
		case BREAST_IMPLANTATION : this.strSNOMEDCTID =BreastGYNMammoSNOMEDMap.BREAST_IMPLANTATION.getSNOMEDCTID(); break;
		case REDUCTION_MAMMOPLASTY : this.strSNOMEDCTID =BreastGYNMammoSNOMEDMap.REDUCTION_MAMMOPLASTY.getSNOMEDCTID(); break;
		case BREAST_RECONSTRUCTION : this.strSNOMEDCTID =BreastGYNMammoSNOMEDMap.BREAST_RECONSTRUCTION.getSNOMEDCTID(); break;
		case REMOVAL_OF_BREAST_IMPLANT : this.strSNOMEDCTID =BreastGYNMammoSNOMEDMap.REMOVAL_OF_BREAST_IMPLANT.getSNOMEDCTID(); break;
		}
	}
	/**
	 * Sets the value for MammoplastyProcedures
	 * @param enumMammoplastyProcedures Object of EnumCM_MammoplastyProcedures.
	 */
	public void setMammoplastyProcedures(EnumCM_MammoplastyProcedures enumMammoplastyProcedures)
	{
		/**
		 * Retrieves the value for CodingSchemeDesignator, CodingSchemeVersion and Code Meaning and 
		 * sets the Code Value according to Code Meaning.
		 */
		this.strCodeMeaning = enumMammoplastyProcedures.getValue();
		this.strCodingSchemeDesignator = EnumCodingSchemeDesignator.SRT.getValue();
		
		/**
		 * set code Value
		 */
		setCodeValue(enumMammoplastyProcedures);
		/**
		 * set SNOMED-CT ID
		 */
		setSNOMEDCTID(enumMammoplastyProcedures);
	}
}
